
#include <avr/io.h>			/* Device include file */
#include <util/delay.h>

//#include "suart.h"
#include "typedef.h"

#ifndef __MMC_H__





/* Status of Disk Functions */
//typedef BYTE	DSTATUS;

/*-------------------------------------------------------------------------*/
/* Platform dependent macros and functions needed to be modified           */
/*-------------------------------------------------------------------------*/

#define SELECT_MMC()	PORTB &= ~_BV(PORTB2)	/* CS = L */
#define	DESELECT_MMC()	PORTB |=  _BV(PORTB2)	/* CS = H */
#define MMCPOWER_ON()	/*PORTD |=  _BV(PORTD2)*/
#define MMCPOWER_OFF()	/*PORTD &= ~_BV(PORTD2)*/
#define	MMC_SEL		!(PORTB &  _BV(PORTB2))	/* CS status (true:CS == L) */

/*--------------------------------------------------------------------------

	 Module Private Functions

	 ---------------------------------------------------------------------------*/

/* Definitions for MMC/SDC command */
#define CMD0	(0x40+0)	/* GO_IDLE_STATE */
#define CMD1	(0x40+1)	/* SEND_OP_COND (MMC) */
#define	ACMD41	(0xC0+41)	/* SEND_OP_COND (SDC) */
#define CMD8	(0x40+8)	/* SEND_IF_COND */
#define CMD16	(0x40+16)	/* SET_BLOCKLEN */
#define CMD17	(0x40+17)	/* READ_SINGLE_BLOCK */
#define CMD24	(0x40+24)	/* WRITE_BLOCK */
#define CMD55	(0x40+55)	/* APP_CMD */
#define CMD58	(0x40+58)	/* READ_OCR */


/* Card type flags (CardType) */
#define CT_MMC				0x01	/* MMC ver 3 */
#define CT_SD1				0x02	/* SD ver 1 */
#define CT_SD2				0x04	/* SD ver 2 */
#define CT_BLOCK			0x08	/* Block addressing */

static BYTE CardType;

BYTE mmc_init();

//static
BYTE send_cmd(
	BYTE cmd,		/* 1st byte (Start + Index) */
	DWORD arg		/* Argument (32 bits) */
	);

#define __MMC_H__
#endif

